#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define FAST ios_base::sync_with_stdio(false);cin.tie(0);cout.tie(0);cerr.tie(0)
#define mp make_pair
#define xx first
#define yy second
#define pb push_back
#define pf push_front
#define popb pop_back
#define popf pop_front
#define all(x) (x).begin(),(x).end()
#define inv(n) power((n), mod - 2)
#define ff(i,a,b) for (int (i) = (a); (i) < (b); (i)++)
#define fff(i,a,b) for (int (i) = (a); (i) <= b; (i)++)
#define bff(i,a,b) for (int (i) = (b)-1; (i) >= (a); (i)--)
#define bfff(i,a,b) for (int (i) = (b); (i) >= (a); (i)--)
#define sum_overflow(a,b) __builtin_add_overflow_p ((a), (b), (__typeof__ ((a) + (b))) 0)
#define mul_overflow(a,b) __builtin_mul_overflow_p ((a), (b), (__typeof__ ((a) + (b))) 0)

using namespace std;
long double typedef ld;
unsigned int typedef ui;
long long int typedef li;
pair<int,int> typedef pii;
pair<li,li> typedef pli;
pair<ld,ld> typedef pld;
vector<vector<int>> typedef graph;
unsigned long long int typedef ull;
//const int mod = 998244353;
const int mod = 1000000007;

using namespace __gnu_pbds;
template <class T> using oset = tree<T, null_type,less<T>, rb_tree_tag,tree_order_statistics_node_update>;
template <class T> using omset = tree<T, null_type,less_equal<T>, rb_tree_tag,tree_order_statistics_node_update>;







//Note to self: Check for overflow

string tip[10004];
int need[10004];
int ans[4][10004];

int main()
{
    FAST;

    int n,o,a,b,ab;
    cin>>n>>o>>a>>b>>ab;
    ff(i,0,n) cin>>tip[i]>>need[i];

    ff(i,0,n) if (tip[i]=="O") ans[0][i]+=need[i],o-=need[i];
    if (o<0) return cout<<"nemoguce",0;
    ff(i,0,n)
    {
        if (tip[i]=="A")
        {
            if (need[i]>a)
            {
                ans[1][i]+=a;
                need[i]-=a,a=0;
                ans[0][i]+=need[i];
                o-=need[i];
            }
            else ans[1][i]+=need[i],a-=need[i];
        }
        else if (tip[i]=="B")
        {
            if (need[i]>b)
            {
                ans[2][i]+=b;
                need[i]-=b,b=0;
                ans[0][i]+=need[i];
                o-=need[i];
            }
            else ans[2][i]+=need[i],b-=need[i];
        }
    }
    if (o<0) return cout<<"nemoguce",0;

    ff(i,0,n)
    {
        if (tip[i]=="AB")
        {
            if (need[i]>o)
            {
                ans[0][i]+=o;
                need[i]-=o,o=0;
            }
            else ans[0][i]+=need[i],o-=need[i],need[i]=0;

            if (need[i]>a)
            {
                ans[1][i]+=a;
                need[i]-=a,a=0;
            }
            else ans[1][i]+=need[i],a-=need[i],need[i]=0;

            if (need[i]>b)
            {
                ans[2][i]+=b;
                need[i]-=b,b=0;
            }
            else ans[2][i]+=need[i],b-=need[i],need[i]=0;

            if (need[i]>ab)
            {
                ans[3][i]+=ab;
                need[i]-=ab,ab=0;
            }
            else ans[3][i]+=need[i],ab-=need[i],need[i]=0;

            if (need[i]>0) return cout<<"nemoguce",0;
        }
    }

    cout<<"moguce\n";
    ff(i,0,n)
    {
        ff(j,0,4) cout<<ans[j][i]<<" ";
        cout<<"\n";
    }
}

//Note to self: Check for overflow